clear
%data
Lc=120; %chips
p0=1/4; %prob. of 0
SF=[4 4 4 4]; %spreading factors of the users
% we have 4 users
% usable pattern 2, 4, 8, 8
%                2, 8, 8, 8
%                4, 4, 4, 4  or higher factors

H{1}=1;
H{2}=[H{1}, H{1}; H{1} -H{1}];
H{3}=[H{2}, H{2}; H{2} -H{2}];
H{4}=[H{3}, H{3}; H{3} -H{3}];

user=ones(1,4);
%user 1
Hm=H{log2(SF(1))+1};
LnInfo1=Lc/SF(1);
bits_to_show1=LnInfo1;
inH1=Hm(1,:);
ouH1m=inH1'*ones(1,LnInfo1);
ouH1=reshape(ouH1m,1,prod(size(ouH1m)));
inInfo1=1-2*(rand(1,LnInfo1)>p0);
inInfo1Sm=inInfo1'*ones(1,SF(1));
inInfo1S=reshape(inInfo1Sm',1,prod(size(inInfo1Sm)));
outInfo1S=inInfo1S.*ouH1(1:length(inInfo1S));
rebInfo1S=outInfo1S.*ouH1(1:length(inInfo1S));
rebInfo1Sm=(reshape(rebInfo1S,SF(1),LnInfo1))';
rebInfo1=(sum(rebInfo1Sm,2)<0)';

%user 2
Hm=H{log2(SF(2))+1};
LnInfo2=Lc/SF(2);
bits_to_show2=LnInfo2;
%cerca un canale libero
free=0; index=0; l1=min(size(Hm,2),length(inH1));
while free==0 && index < size(Hm,1)
    index=index+1;
    if abs(sum(Hm(index,1:l1).*inH1(1:l1)))==0
        free=1;
    end
    if index==size(Hm,1) && free==0;
        disp('channels all busy for user 2');
        user(2)=0;
    end
end
inH2=Hm(index,:);
ouH2m=inH2'*ones(1,LnInfo2);
ouH2=reshape(ouH2m,1,prod(size(ouH2m)));
inInfo2=1-2*(rand(1,LnInfo2)>p0);
inInfo2Sm=inInfo2'*ones(1,SF(2));
inInfo2S=reshape(inInfo2Sm',1,prod(size(inInfo2Sm)));
outInfo2S=inInfo2S.*ouH2(1:length(inInfo2S));
rebInfo2S=outInfo2S.*ouH2(1:length(inInfo2S));
rebInfo2Sm=(reshape(rebInfo2S,SF(2),LnInfo2))';
rebInfo2=(sum(rebInfo2Sm,2)<0)';


%user 3
Hm=H{log2(SF(3))+1};
LnInfo3=Lc/SF(3);
bits_to_show3=LnInfo3;
%cerca un canale libero
free=0; index=0;
while free==0  && index < size(Hm,1)
    index=index+1;
    l1=min(size(Hm,2),length(inH1));
    free=abs(sum(Hm(index,1:l1).*inH1(1:l1)))==0;
    if user(2)==1
        l2=min(size(Hm,2),length(inH2));
        free=free*(abs(sum(Hm(index,1:l2).*inH2(1:l2)))==0);
    end
    if index==size(Hm,1) && free==0
        disp('channels all busy for user 3');
        user(3)=0;
    end

end
inH3=Hm(index,:);
ouH3m=inH3'*ones(1,LnInfo3);
ouH3=reshape(ouH3m,1,prod(size(ouH3m)));
inInfo3=1-2*(rand(1,LnInfo3)>p0);
inInfo3Sm=inInfo3'*ones(1,SF(3));
inInfo3S=reshape(inInfo3Sm',1,prod(size(inInfo3Sm)));
outInfo3S=inInfo3S.*ouH3(1:length(inInfo3S));
rebInfo3S=outInfo3S.*ouH3(1:length(inInfo3S));
rebInfo3Sm=(reshape(rebInfo3S,SF(3),LnInfo3))';
rebInfo3=(sum(rebInfo3Sm,2)<0)';

%user 4
Hm=H{log2(SF(4))+1};
LnInfo4=Lc/SF(4);
bits_to_show4=LnInfo4;
%cerca un canale libero
free=0; index=0;
while free==0  && index < size(Hm,1)
    index=index+1;
    free=abs(sum(Hm(index,1:l1).*inH1(1:l1)))==0;
    if user(2)==1
        l2=min(size(Hm,2),length(inH2));
        free=free*(abs(sum(Hm(index,1:l2).*inH2(1:l2)))==0);
    end
    if user(3)==1
        l3=min(size(Hm,2),length(inH3));
        free=free*(abs(sum(Hm(index,1:l3).*inH3(1:l3)))==0);
    end
    if index==size(Hm,1) && free==0
        disp('channels all busy for user 4');
        user(4)=0;
    end
    
end


inH4=Hm(index,:);
ouH4m=inH4'*ones(1,LnInfo4);
ouH4=reshape(ouH4m,1,prod(size(ouH4m)));
inInfo4=1-2*(rand(1,LnInfo4)>p0);
inInfo4Sm=inInfo4'*ones(1,SF(4));
inInfo4S=reshape(inInfo4Sm',1,prod(size(inInfo4Sm)));
outInfo4S=inInfo4S.*ouH4(1:length(inInfo4S));
rebInfo4S=outInfo4S.*ouH4(1:length(inInfo4S));
rebInfo4Sm=(reshape(rebInfo4S,SF(4),LnInfo4))';
rebInfo4=(sum(rebInfo4Sm,2)<0)';


onthechannel=outInfo1S+user(2)*outInfo2S+user(3)*outInfo3S+user(4)*outInfo4S;

rebInfo1S=onthechannel.*ouH1(1:length(inInfo1S));
rebInfo1Sm=(reshape(rebInfo1S,SF(1),LnInfo1))';
rebInfo1=(sum(rebInfo1Sm,2)<0)';

subplot(5,1,1);
stem(inInfo1(1:bits_to_show1)<0);
title('user 1 data');
subplot(5,1,2);
stem(outInfo1S(1:bits_to_show1*SF(1)));
title('user 1 spread sequence (SF=2)');
subplot(5,1,3);
stem(onthechannel(1:bits_to_show1*SF(1)),'ko');
title('sum of spread sequences');
subplot(5,1,4);
stem(rebInfo1S(1:bits_to_show1*SF(1)),'ko');
title('user 1 despread sequence');
subplot(5,1,5);
stem(rebInfo1(1:bits_to_show1),'ko');
title('user 1 detected data');

if user(2)>0
    rebInfo2S=onthechannel.*ouH2(1:length(inInfo2S));
    rebInfo2Sm=(reshape(rebInfo2S,SF(2),LnInfo2))';
    rebInfo2=(sum(rebInfo2Sm,2)<0)';
    figure;

    subplot(5,1,1);
    stem(inInfo2(1:bits_to_show2)<0);
    title('user 2 data');
    subplot(5,1,2);
    stem(outInfo2S(1:bits_to_show2*SF(2)));
    title('user 2 spread sequence (SF=8)');
    subplot(5,1,3);
    stem(onthechannel(1:bits_to_show2*SF(2)),'ko');
    title('sum of spread sequences');
    subplot(5,1,4);
    stem(rebInfo2S(1:bits_to_show2*SF(2)),'ko');
    title('user 2 despread sequence');
    subplot(5,1,5);
    stem(rebInfo2(1:bits_to_show2),'ko');
    title('user 2 detected data');
end

if user(3)>0
    rebInfo3S=onthechannel.*ouH3(1:length(inInfo3S));
    rebInfo3Sm=(reshape(rebInfo3S,SF(3),LnInfo3))';
    rebInfo3=(sum(rebInfo3Sm,2)<0)';

    figure;

    subplot(5,1,1);
    stem(inInfo3(1:bits_to_show3)<0);
    title('user 3 data');
    subplot(5,1,2);
    stem(outInfo3S(1:bits_to_show3*SF(3)));
    title('user 3 spread sequence (SF=4)');
    subplot(5,1,3);
    stem(onthechannel(1:bits_to_show3*SF(3)),'ko');
    title('sum of spread sequences');
    subplot(5,1,4);
    stem(rebInfo3S(1:bits_to_show3*SF(3)),'ko');
    title('user 3 despread sequence');
    subplot(5,1,5);
    stem(rebInfo3(1:bits_to_show3),'ko');
    title('user 3 detected data');
end

if user(4)>0
    rebInfo4S=onthechannel.*ouH4(1:length(inInfo4S));
    rebInfo4Sm=(reshape(rebInfo4S,SF(4),LnInfo4))';
    rebInfo4=(sum(rebInfo4Sm,2)<0)';

    figure;

    subplot(5,1,1);
    stem(inInfo4(1:bits_to_show4)<0);
    title('user 4 data');
    subplot(5,1,2);
    stem(outInfo4S(1:bits_to_show4*SF(4)));
    title('user 4 spread sequence (SF=8)');
    subplot(5,1,3);
    stem(onthechannel(1:bits_to_show4*SF(4)),'ko');
    title('sum of spread sequences');
    subplot(5,1,4);
    stem(rebInfo4S(1:bits_to_show4*SF(4)),'ko');
    title('user 4 despread sequence');
    subplot(5,1,5);
    stem(rebInfo4(1:bits_to_show4),'ko');
    title('user 4 detected data');
end
